/******************************************************************************
*
* project name:    Scorch
* file name:       Gamefunc##.c
* initial date:    27.12.2004
* author:          mhubi@freesurf.ch
* description:     all specific game functions
*
*******************************************************************************
*
* Scorch -- another tank-game
* Copyright (C) 2004-2005  Martin Huber
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#include "main-h13.h"


void Landscape(unsigned int land_factor) {
	
	unsigned int loop1, high;
	
	/*high = LCD_HEIGHT-random(CALC(60,90));
	highold = high;
	
	for (loop1 = 0; loop1 < CALC(160,240); loop1++) {
		high -= (2 + land_factor - random(5 + 2*land_factor));
		if (high > CALC(100,128) - 8) {
			high = CALC(100,128) - 8 - random(land_factor);
		}
		if (high < CALC(47,52)) {
			high += 4;
		}
		earth[loop1] = high;
		if (high-highold >= 2 + land_factor/2 && loop1 != 0) {
			earth[loop1] -= (1+land_factor/2);
		}
		if (highold - high >= 2 + land_factor/2 && loop1 != 0) {
			earth[loop1 - 1] -= (1+land_factor/2); 
		}
		
		highold = high;
		
		earth[loop1] = 100;
		
	}*/
	
	//high = LCD_HEIGHT - random(CALC(60,90));
	//high = 60 - random(20);
	
	
	high = CALC(65,95) - random(10);
	land_factor *= 2;
	land_factor += 2;
	
	
	for (loop1 = 0; loop1 < CALC(160,240); loop1++) {
		
		high -= (land_factor/2 - random(land_factor + 1));
		
		if (high > CALC(100,128) - 8) {
			high -= random(land_factor);
		}
		else if (high < CALC(47, 52)) {
			high += random(land_factor);
		}
		
		earth[loop1] = high;		
		
	}
	
}

void DrawScreen(void) {
	
	unsigned int loop1;
	
	for (loop1 = 0; loop1 <= CALC(159,239); loop1++) {
		
		FastDrawVLine(DPLANE, loop1, earth[loop1], CALC(99,127), A_NORMAL);
		
	}
	
	//Clouds();
	
	//Debugging(0);
	
	for (loop1 = 0; loop1 < game->pl_num; loop1++) {
		if (player[loop1].life == 1) {
			//Tankset(loop1);
			MaskTank(loop1);
			DrawTank(loop1, player[loop1].protect);
			Tube(loop1);
		}
	}
	
	Dispinf(game->pl_active);
	
}

void InitRound(void) {
	
	//values and display of the beginning
	game->pl_alive = game->pl_num;
	
	if (game->set[WIND] == 0) {
		game->wind = 0;
	}
	else if (game->set[WIND] == 1 || game->set[WIND] == 4) {
		game->wind = 10 - random(20);
	}
	else if (game->set[WIND] == 2 || game->set[WIND] == 5) {
		game->wind = 25 - random(50);
	}
	else if (game->set[WIND] == 3 || game->set[WIND] == 6) {
		game->wind = 50 - random(100);
	}
	//game->wind = 0;
	
	//for each player
	for (game->pl_active = 0; game->pl_active < game->pl_num; game->pl_active++) {
		
		//if (player[game->pl_active].type == 2) {
			//beginning-values for the ai
			/*while (player[game->pl_active].hit == game->pl_active) {
				player[game->pl_active].hit = random(game->pl_num);
			}*/
			//chose the angle
			//#if defined(TESTING)
			//ChooseEnnemi(game->pl_active, FALSE);
			/*#else
			if (game->wind >= 0) {
				player[game->pl_active].angle = 10 + random(70);
			}
			if (game->wind < 0) {
				player[game->pl_active].angle = 100 + random (70);
			}
			#endif*/
			
			//player[game->pl_active].angle_img = player[game->pl_active].angle;
			
		//}
		
		player[game->pl_active].bomb[0] = 1;
		player[game->pl_active].health = 10;
		player[game->pl_active].x = 15 + random(CALC(10,15)) + game->pl_active*(LCD_WIDTH / game->pl_num);
		player[game->pl_active].life = 1;
		player[game->pl_active].protect = 0;
		player[game->pl_active].shield = 0;
		
	}
	
}

//void Tankset(PLAYERINF *player) {
void Tankset(unsigned int num) {
	
	//unsigned int loop1;
	int loop2;
	
	//for (loop1 = 0; loop1 < game->pl_num; loop1++) {
		
		player[num].y = earth[player[num].x] - 1;
		
		for (loop2 = -4; loop2 <= 4; loop2++) {
				
				earth[player[num].x + loop2] = earth[player[num].x];
			
		}
		
	//}
	
	/*MaskTank(num);
	
	DrawTank(num, player[num].protect);*/
	
}

void DrawTank(unsigned int num, unsigned int mode) {
	
	//out of bounds --> possible error --> clipped if necessary
	GraySprite16_OR_R(player[num].x-11,player[num].y -4,5,player[num].tank,player[num].tank,LPLANE,DPLANE);
	
	if (mode == 0) {
		//GrayDrawRect(player[num].x - 1, player[num].y + 1, player[num].x + 1, CALC(99,127), COLOR_DARKGRAY, RECT_FILLED);
		Tube(num);
	}
	else if (mode == PARACHUTE) {
		Sprite8_OR(player[num].x - 3, player[num].y - 8, 4, parachute, DPLANE);
	}
	/*if (player[num].shield > 0 && num != game->pl_active) {
		ClipCircle(player[num].x, player[num].y - 4, 7, COLOR_BLACK, OUTLINED);
		ClipCircle(player[num].x, player[num].y - 4, 8, COLOR_BLACK, OUTLINED);
		//ClipCircle(player[num].x, player[num].y - 4, 13, COLOR_WHITE);
	}*/
	
}

void MaskTank(unsigned int num) {
	
	Sprite16_AND(player[num].x - 6, player[num].y - 4, 5, tank_mask, DPLANE);
	Sprite16_AND(player[num].x - 6, player[num].y - 4, 5, tank_mask, LPLANE);
	Sprite16_AND(player[num].x - 6, player[num].y - 9, 5, tank_mask, DPLANE);
	Sprite16_AND(player[num].x - 6, player[num].y - 9, 5, tank_mask, LPLANE);
	
}

void Tube(unsigned int num) {
	
	int tile = (int)(player[num].angle_img/9);
	
	Sprite16_AND(player[num].x - 6, player[num].y - 9, 5, tank_mask, DPLANE);
	Sprite16_AND(player[num].x - 6, player[num].y - 9, 5, tank_mask, LPLANE);
	
	Sprite8_OR(player[num].x - 4, player[num].y - 8, 4, tube[tile], DPLANE);
	Sprite8_OR(player[num].x - 4, player[num].y - 8, 4, tube[tile], LPLANE);
	
	
}

void MainShot(unsigned int num, TARGET *target) {
	
	BOOL explo = TRUE;
	
	if (player[num].bomb[0] != LASERLITTLE && player[num].bomb[0] != LASERBIG) {
		explo = ShotEngine(player[num].x, player[num].y, player[num].angle, player[num].power, num, target);
	}
	
	/*MoveTo(1, 21);
			
	printf("%d, %d;", target->x, target->y);
	
	Waitkey();
	
	ClrScr();
	DrawScreen();*/
	
	Explosion(target->x, target->y, num, explo);
	
}

BOOL ShotEngine(int x_p, int y_p, int angle_p, int power_p, unsigned int num, TARGET *target) {
	
	COORDINATES scoord;
	float t = 0, t_wind = 0;
	scoord.x_new = 0, scoord.y_new = 0; 
	
	target->x = 20; target->y = 30;
	
	int x, y, angle, wind_sum = 0, dir = 0, wind = game->wind;
	int control1 = 0, loop1 = 0;
	
	angle = (angle_p * -1) + 90;
	x = x_p + 1 + TUBELENGTH * sin_deg(angle);
	y = y_p - 5 - TUBELENGTH * cos_deg(angle);
	scoord.x_old = x, scoord.y_old = y;
	scoord.x_eld = x, scoord.y_eld = y;
	scoord.x_ild = x, scoord.y_ild = y;
	
	EXT_CLRPIX(DPLANE, x, y);
	EXT_CLRPIX(LPLANE, x, y);
	
	while(control1 == 0) {
		
		loop1++;
		
		t+=0.06;
		t_wind+=0.06;
		
		if (_keytest(RR_F2)) {
			LeadOut(FASTQUIT);
		}
		
		scoord.x_new = x + power_p*POWERFACTOR*t*sin_deg(angle) + wind/2*t_wind*t_wind + wind_sum;
		scoord.y_new = y - (power_p*POWERFACTOR*t*cos_deg(angle) - GRAVITATION*t*t);
		
		if (scoord.y_new < CALC(17,21)) {
			scoord.y_new = CALC(17,21);
		}
		
		
		if (scoord.x_new > (dir + 1)*CALC(160,240) - 1) {
			dir++;
			if (game->set[WALLS] == 1) {
				wind_sum += wind/2*t_wind*t_wind;
				wind *= -1;
				t_wind = 0;
			}
			else if (game->set[WALLS] == 2) {
				control1 = 20;
			}
		}
		else if (scoord.x_new < dir*CALC(160,240)) {
			dir--;
			if (game->set[WALLS] == 1) {
				wind_sum += wind/2*t_wind*t_wind;
				wind *= -1;
				t_wind = 0;
			}
			else if (game->set[WALLS] == 2) {
				control1 = 20;
			}
		}
		
		scoord.x_new -= dir*CALC(160,240);
		
		
		if (dir % 2 && game->set[WALLS] == 1) {
			scoord.x_new = CALC(159,239) - scoord.x_new;
		}
		
		/*while (scoord.x_new > CALC(159,239)) {
			scoord.x_new-=CALC(160,240);
		}
		while (scoord.x_new < 0) {
			scoord.x_new+=CALC(160,240);
		}
		if (scoord.y_new < CALC(17,21)) {
			scoord.y_new = CALC(17,21);
		}*/
		//else if (scoord.y_new > CALC(99,127)) {
		//	scoord.y_new = CALC(99,127);
		//}
	
		EXT_CLRPIX(DPLANE, scoord.x_old, scoord.y_old);
		EXT_CLRPIX(LPLANE, scoord.x_old, scoord.y_old);
		EXT_CLRPIX(DPLANE, scoord.x_eld, scoord.y_eld);
		EXT_CLRPIX(LPLANE, scoord.x_ild, scoord.y_ild);
		
		//control1 = EXT_GETPIX(DPLANE, scoord.x_new, scoord.y_new);
		
		/*if (EXT_GETPIX(DPLANE, scoord.x_new, scoord.y_new)) {
			
			control1 = TRUE;
			
			target->x = scoord.x_new;
			target->y = scoord.y_new;
			
			MoveTo(1, 21);
			
			printf("%d, %d; %d, %d", scoord.x_new, scoord.y_new, target->x, target->y);
			
			Waitkey();
			
			ClrScr();
			DrawScreen();
			
		}*/
		
		if (scoord.x_old - scoord.x_new > 100 && game->set[WALLS] == 0) {
			
			control1 = CheckImpact(scoord.x_old, scoord.y_old, CALC(159,239), scoord.y_old + (scoord.y_new - scoord.y_old)/2, target);
			control1 += CheckImpact(0, scoord.y_old + (scoord.y_new - scoord.y_old)/2, scoord.x_new, scoord.y_new, target);
			
		}
		else if (scoord.x_new - scoord.x_old > 100 && game->set[WALLS] == 0) {
			
			control1 = CheckImpact(scoord.x_old, scoord.y_old, 0, scoord.y_old + (scoord.y_new - scoord.y_old)/2, target);
			control1 += CheckImpact(CALC(159,239), scoord.y_old + (scoord.y_new - scoord.y_old)/2, scoord.x_new, scoord.y_new, target);
			
		}
		else if (control1 == 0) {
	
			control1 = CheckImpact(scoord.x_old, scoord.y_old, scoord.x_new, scoord.y_new, target);
		}
		
		/*if (control1 != 0) {
			
			//control1 = TRUE;
			
			//target->x = scoord.x_new;
			//target->y = scoord.y_new;
			
			MoveTo(1, 21);
			
			printf("%d, %d; %d, %d", scoord.x_new, scoord.y_new, target->x, target->y);
			
			Waitkey();
			
			ClrScr();
			DrawScreen();
			
		}*/
		
		
		/*if (scoord.y_new == CALC(98,126)) {
			control1 = 1;
			target->x = scoord.x_new;
			target->y = scoord.y_new;
		}*/
		
		if (loop1 <= 1 && control1 != 0 && num < 5) {
			/*if (TestCollide8(player[num].x - 4, player[num].y - 8, target->x - 7, target->y, 4,
					tube[(int)(player[num].angle_img/9)], projectile) == TRUE) {
				control1 = 0;
			}*/
			if (PixCollide8(target->x, target->y, x_p - 4, y_p - 8, 4, 
					tube[(int)(player[num].angle_img/9)]) != 0) {//== TRUE) {
				control1 = 0;
			}
			
		}
		
		
		if (control1 == 0) {
			EXT_SETPIX(LPLANE, scoord.x_new, scoord.y_new);
			EXT_SETPIX(DPLANE, scoord.x_new, scoord.y_new);
		}
		EXT_SETPIX(DPLANE, scoord.x_old, scoord.y_old);
		EXT_SETPIX(LPLANE, scoord.x_eld, scoord.y_eld);
		
		scoord.x_ild = scoord.x_eld, scoord.y_ild = scoord.y_eld;
		scoord.x_eld = scoord.x_old, scoord.y_eld = scoord.y_old;
		scoord.x_old = scoord.x_new, scoord.y_old = scoord.y_new;
		
		Delay(15);
		
	}
	
	
	EXT_CLRPIX(DPLANE, scoord.x_eld, scoord.y_eld);
	EXT_CLRPIX(LPLANE, scoord.x_ild, scoord.y_ild);
	
	if (control1 == 20) {
		return FALSE;
	}
	
	return TRUE;
	
}

int CheckImpact(int xP, int yP, int xQ, int yQ, TARGET *target) {
	
	int x = xP;
	int y = yP;
	int D = 0;
	int HX = xQ - xP;
	int HY = yQ - yP;
	int xInc = 1;
	int yInc = 1;
	int c, M;
	int on = 0;
	
	if(HX < 0) {
		xInc = -1;
		HX = -HX;
	}
	if(HY < 0) {
		yInc = -1;
		HY = -HY;
	}
	
	if(HY <= HX) {
		
		c = 2 * HX; M = 2 * HY;
		while(TRUE) {
			
			on = EXT_GETPIX(DPLANE, x, y);
			if (on != FALSE) {
    			target->x = x;
    			target->y = y;
    			
    			/*MoveTo(1, 21);
			
					printf("%d; %d, %d; %d, %d", on, x, y, target->x, target->y);
			
					Waitkey();
			
					ClrScr();
					DrawScreen();*/
    			
    			return on;
    	}
    	else {
    		EXT_CLRPIX(LPLANE, x, y);
    	}
    	
			if(x == xQ) {
				return on;
			}
			x += xInc;
			D += M;
			if(D > HX) {
				y += yInc;
				D -=c;
			}
		
		}
		
	}
	else {
		
		c = 2 * HY; M = 2 * HX;
		while(TRUE) {
			
			on = EXT_GETPIX(DPLANE, x, y);
			if (on != FALSE) {
	    	target->x = x;
	    	target->y = y;			
	    		
	    	/*MoveTo(1, 21);
		
				printf("%d; %d, %d; %d, %d", on, x, y, target->x, target->y);
		
				Waitkey();
		
				ClrScr();
				DrawScreen();*/
	    			
	    	return on;
	    			
	    }
	    else {
	    	EXT_CLRPIX(LPLANE, x, y);
	    }
	    
			if(y == yQ) {
				return on;
			}
			y += yInc;
			D += M;
			if(D > HY) {
				x += xInc;
				D -=c;
			}
		
		} 
		
	}

	return on;

}

void NormalBomb(unsigned int x, unsigned int y, unsigned int width) {
	
	unsigned int loop1, loop2, color = 0;
	
	for (loop1 = 1; loop1 <= width; loop1++) {
		if (loop1 == width) {
			color = 0;
		}
		ClipCircle(x,y,loop1,color,FILLED);
		color++;
		if (color > 3) {
			color = 0;
		}
		for (loop2 = 0; loop2 <= 46; loop2++) {
			#if defined(VTI)
			VTIPoking();
			#else
			pokeIO(0x600005, 0b10111);
			#endif
		}
		
	}
	
}

void ClipCircle(int xc, int yc, int r, int color, unsigned int mode) {
	int x = 0, y = r, d = 2 * (1 - r);
	int x1, y1, x2;
	
	while (y >= 0) {
		x1 = xc - x;
		x2 = xc + x;
		y1 = yc + y;
		x1 = (x1 < 0) ? 0 : x1;
		x1 = (x1 > CALC(159,239)) ? CALC(159,239) : x1;
		x2 = (x2 < 0) ? 0 : x2;
		x2 = (x2 > CALC(159,239)) ? CALC(159,239) : x2;
		if ((x2 < CALC(159,239)) && ((x2 - x1) > 16)) {        
			if ((y1 >= CALC(17,21)) && (y1 < CALC(99,127))) {
				if (mode == FILLED) {
					FastDrawGrayHLine(x1, x2, y1, color);
				}
				/*else {
					CirclePixel(x1, x2, y1);
				}*/
			}
			y1 = yc -y;
			if ((y1 >= CALC(17,21)) && (y1 < CALC(99,127))) {
				if (mode == FILLED) {
					FastDrawGrayHLine(x1, x2, y1, color);
				}
				/*else {
					CirclePixel(x1, x2, y1);
				}*/
			}
		} else {
			if ((y1 >= CALC(17,21)) && (y1 < CALC(99,127))) {
				if (mode == FILLED) {
					FastDrawGrayLine(x1, y1, x2, y1, color);
				}
				/*else {
					CirclePixel(x1, x2, y1);
				}*/
			}
			y1 = yc - y;
			if ((y1 >= CALC(17,21)) && (y1 < CALC(99,127))) {
				if (mode == FILLED) {
					FastDrawGrayLine(x1, y1, x2, y1, color);
				}
				/*else {
					CirclePixel(x1, x2, y1);
				}*/
			}
		}
		if(d + y > 0) {
			y--;
			d -= (y << 1) - 1;
		}
		if(x > d) {
			x++;
			d += (x << 1) + 1;
		}
	}
}

/*void CirclePixel(int x1, int x2, int y1) {
		
		EXT_SETPIX(DPLANE, x1, y1); 
		EXT_SETPIX(DPLANE, x2, y1); 
		EXT_SETPIX(LPLANE, x1, y1); 
		EXT_SETPIX(LPLANE, x2, y1);
	
}*/


void Napalm(int x, unsigned int napalm_length) {
	
	unsigned int loop1, loop2 = 0, y_loop;
	int x_max, x_min, y;
	unsigned int scenario, number, pos[12]; //overflow
	
	x_max = x;
	x_min = x;
	y = earth[x] - 1;
	
	EXT_SETPIX(LPLANE, x, y);
	EXT_SETPIX(DPLANE, x, y);
	
	for (loop1 = 0; loop1 < napalm_length; loop1++) {
		
		scenario = 0;
		
		if (!EXT_GETPIX(DPLANE, x + 1, y)) {
			scenario = 2;
		}
		if (!EXT_GETPIX(DPLANE, x - 1, y)) {
			scenario++;
		}
		else {
			y--;
		}
		
		if (scenario != 0) {
			
			
			if (scenario == 1) {
				x--;
			}
			else if (scenario == 2) {
				x++;
			}
			else if (scenario == 3) {
				if (random(2) == 0) {
					x--;
				}
				else {
					x++;
				}
			}
			
			for (;!EXT_GETPIX(DPLANE, x, y);y++);
			y--;
		
		}
		
		for (loop2 = 0; loop2 < 42; loop2++) {
			
			#if defined(VTI)
			VTIPoking();
			#else
			pokeIO(0x600005, 0b10111);
			#endif
			
			if (_keytest(RR_F2)) {
				LeadOut(FASTQUIT);
			}
			
		}
		
		EXT_SETPIX(LPLANE, x, y);
		EXT_SETPIX(DPLANE, x, y);
		
		if (x > x_max) {
			x_max = x;
		}
		else if (x < x_min) {
			x_min = x;
		}
		
		if (x == 0) {
			break;
		}
		else if (x == CALC(159,239)) {
			break;
		}
		
	}
	
	scenario = (int)(x_max - x_min)/9;
	if (scenario == 0 || (x_max - x_min)%9 > 4) {
		scenario++;
	}
	
	for (loop1 = 0; loop1 < scenario; loop1++) {
		
		for (y_loop = CALC(17,21); !EXT_GETPIX(DPLANE, x_min + loop1*9 + 4, y_loop); y_loop++);
		y_loop--;
		
		pos[loop1] = y_loop;
		
		
		
	}
	
	for (loop1 = 0; loop1 < 15; loop1++) {
		
		for (loop2 = 0; loop2 < scenario; loop2++) {
			
			number = random(3)*2;
			
			GrayClipSprite8_OR_R(x_min + loop2*9,  pos[loop2] - 11, 12, fire[number], fire[number+1], LPLANE, DPLANE);
		
		}	
		
		for (loop2 = 0; loop2 < 83; loop2++) {
			
			#if defined(VTI)
			VTIPoking();
			#else
			pokeIO(0x600005, 0b10111);
			#endif
			
			if (_keytest(RR_F2)) {
				LeadOut(FASTQUIT);
			}
			
		}
		
		for (loop2 = 0; loop2 < scenario; loop2++) {
			
			GrayClipSprite8_AND_R(x_min + loop2*9,  pos[loop2] - 11, 12, fire[6], fire[6], LPLANE, DPLANE);
		
		}
			
	}
	
	HealthControl(1, x_min, x_max, TRUE);
	
	//Waitkey();
	
	GrayClearScreen();
	DrawScreen();
	DrawClouds();
	
}

void Laser(int x_p, int y_p, int angle_p, unsigned int width) {
	
	int xy_diff[5][4] = {{0,1,0,-1},{-1,1,-1,0},{1,0,-1,0},{0,1,0,-1},{0,-1,0,1}};
	int x1, x2, xlong, y1, y2, ylong, loop1, color, angle;
	unsigned int loop2;
	
	//width = bomb_skill[player[num].bomb[0] - 1][2];
	angle = (angle_p * -1) + 90;
	x1 = x_p + 1 + TUBELENGTH*sin_deg(angle);
	y1 = y_p - 5 - TUBELENGTH*cos_deg(angle);
	x2 = x1;
	y2 = y1;
	
	
	for (loop1 = 0; loop1 < 4; loop1++) {
		
		x2 = x1 + width*cos_deg(angle_p);
		y2 = y1 - width*sin_deg(angle_p);
		
		if (x2 < 1) {
			width = ABS((x1 - 1)/cos_deg(angle_p));
		}
		else if (x2 > CALC(158, 238)) {
			width = ABS((CALC(158, 238) - x1)/cos_deg(angle_p));
		}
		else if (y2 < CALC(18,22)) {
			width = ABS((y1 - CALC(18,22))/sin_deg(angle_p));
		}
		else {
			break;
		}
		
	}
	
	xlong = x2 - x1;
	ylong = y2 - y1;
	
	color = COLOR_LIGHTGRAY;
	
	for (loop1 = 0; loop1 < 20; loop1++) {
		
		if (loop1 == 19) {
			color = 0;
		}
		
		GrayFastDrawLine(x1, y1, x2, y2, color);
		GrayFastDrawLine(x1 + xy_diff[angle_p/45][0], 
										 y1 + xy_diff[angle_p/45][1], 
										 x1 + xy_diff[angle_p/45][0] + xlong, 
										 y1 + xy_diff[angle_p/45][1] + ylong, color);
		GrayFastDrawLine(x1 + xy_diff[angle_p/45][2], 
										 y1 + xy_diff[angle_p/45][3], 
										 x1 + xy_diff[angle_p/45][2] + xlong, 
										 y1 + xy_diff[angle_p/45][3] + ylong, color);
		
		color++;
		
		if (color > 3) {
			color = 1;
		}
		
		for (loop2 = 0; loop2 <= 46; loop2++) {
			#if defined(VTI)
			VTIPoking();
			#else
			pokeIO(0x600005, 0b10111);
			#endif
			
			if (_keytest(RR_F2)) {
				LeadOut(FASTQUIT);
			}
			
		}
		
	}
	
	EarthControl(x1, x2);
	
}


void MultiBomb(unsigned int x, unsigned int y, unsigned int width, unsigned int bomb) {
	
	TARGET mtarget;
	
	if (bomb <= DEATHSHEAD) {
		ShotEngine(x, y, 45, 10 + random(20), 10, &mtarget);
	}
	else {
		MultiBombLaser(x, y, &mtarget, TRUE);
	}
	
	NormalBomb(mtarget.x, mtarget.y, width);
	
	if (bomb <= DEATHSHEAD) {
		ShotEngine(x, y, 135, 10 + random(20), 10, &mtarget);
	}
	else {
		MultiBombLaser(x, y, &mtarget, FALSE);
	}
	NormalBomb(mtarget.x, mtarget.y, width);
	
	NormalBomb(x, y, width);
	
	
}


void MultiBombLaser(int x, int y, TARGET *target, BOOL step) {
	
	unsigned int color, loop1, loop2;
	
	target->x = x;
	
	if (step == TRUE) {
		target->x -= random(target->x);
	}
	else {
		target->x += random(CALC(159,239) - target->x);
	}
	
	if (target->x < 5) {
		target->x = 5;
	}
	else if (target->x > CALC(154,234)) {
		target->x = CALC(154,234);
	}
	target->y = earth[target->x];
	
	if (target->y == CALC(99,127)) {
		target->y = CALC(98,126);
	}
	
	color = COLOR_LIGHTGRAY;
	
	for (loop1 = 0; loop1 < 10; loop1++) {
		
		if (loop1 == 9) {
			color = 0;
		}
		
		GrayFastDrawLine(x, y, target->x, target->y, color);
		
		color++;
		
		if (color > 3) {
			color = 1;
		}
		
		for (loop2 = 0; loop2 <= 46; loop2++) {
			#if defined(VTI)
			VTIPoking();
			#else
			pokeIO(0x600005, 0b10111);
			#endif
			
			if (_keytest(RR_F2)) {
				LeadOut(FASTQUIT);
			}
			
		}
		
	}
	
} 

void Explosion(unsigned int x, unsigned int y, unsigned int num, BOOL explo) {
	
	unsigned int /*loop1, loop2, color = 0, */width = 0;
	
	if (y > CALC(98,126)) {
		y = CALC(98,126);
	}
	
	if (player[num].bomb[0] == 0 || num == MASSKILL) {
		width = 6 + random(15);
		num = MASSKILL;
	}
	else if (player[num].bomb[0] == BABYMISSILE) {
		width = 1;
	}
	else {
		--player[num].bomb[player[num].bomb[0]];
		width = bomb_skill[player[num].bomb[0] - 1][2];
	}
	
	if (explo == FALSE) {
		return;
	}
	
	if (player[num].bomb[0] <= NUKE || num == MASSKILL) {
		
		NormalBomb(x, y, width);
		
		/*MoveTo(1, 21);
			
		printf("%d, %d;", x, y);
			
		Waitkey();
			
		ClrScr();
		DrawScreen();*/
		
		/*for (loop1 = 1; loop1 <= width; loop1++) {
			if (loop1 == width) {
				color = 0;
			}
			ClipCircle(x,y,loop1,color,FILLED);
			color++;
			if (color > 3) {
				color = 0;
			}
			for (loop2 = 0; loop2 <= 46; loop2++) {
				#if defined(VTI)
				VTIPoking();
				#else
				pokeIO(0x600005, 0b10111);
				#endif
			}
			
		}*/
		//ClipCircle(x,y,width,0,FILLED);
		
		if (num != MASSKILL) {
			HealthControl(0, 0, 0, TRUE);
		}
		
		/*MoveTo(1, 21);
			
		printf("%d, %d;", x, y);
			
		Waitkey();
			
		ClrScr();
		DrawScreen();*/
		
		//EarthControl(x,y,width);
		EarthControl(x - width - 1, x + width + 1);
		
		if (num != MASSKILL) {
			TankFall(TRUE);
		}
	
	}
	else if (player[num].bomb[0] <= HOTNAPALM) {
		
		Napalm(x, width);
		
		//Waitkey();
		
	}
	else if (player[num].bomb[0] <= LASERBIG) {
		
		Laser(player[num].x, player[num].y, player[num].angle, width);
		
		HealthControl(0, 0, 0, TRUE);
		
		TankFall(TRUE);
		
	}
	else if (player[num].bomb[0] <= EXTMIRV) {
		
		MultiBomb(x, y, width, player[num].bomb[0]);
		
		EarthControl(0, CALC(159,239));
		
		HealthControl(0, 0, 0, TRUE);
		
		TankFall(TRUE);
		
	}
	else if (player[num].bomb[0] <= MONSTERDIGGER) {
		
		Earthquake(x - width/2, x + width/2, 6 - random(3), TRUE);
		
		//TankFall(TRUE);
		
	}
	
	//GrayFastDrawHLine(0, CALC(159,239), CALC(99,127), COLOR_DARKGRAY);
	
	if (player[num].bomb[player[num].bomb[0]] == 0) {
		player[num].bomb[0] = 1;
	}
	
}

void EarthControl(int x_min, int x_max) {
	
	int control1, control2, x, y, fall, temp;
	
	//MoveTo(1, 21);
			
	//printf("%d, %d;", x_min, x_max);
			
	//Waitkey();
	
	if (x_min > x_max) {
		x = x_max;
		x_max = x_min;
		x_min = x;
	}
	
	if (x_min < 0) {
		x_min = 0;
	}
	if (x_max > CALC(159, 239)){
		x_max = CALC(159, 239);
	}
	
	
	for (x = x_min; x <= x_max; x++) {
		
		fall = FALSE;
		temp = 0;
		
		for (y = CALC(99, 127); y > CALC(17, 21); y--) {
			
			control1 = EXT_GETPIX(DPLANE, x, y);
			control2 = EXT_GETPIX(LPLANE, x, y);
			
			if (control1 != FALSE && control2 != FALSE) {
				temp = 1;
			}
			
			if (control1 == FALSE && fall == FALSE && temp == 0) {
				
				fall = TRUE;
				earth[x] = y + 1;
				
			}
			
			
			if (control1 != FALSE && control2 == FALSE && fall != FALSE) {
				
				earth[x]--;
				EXT_CLRPIX(DPLANE, x, y);
				EXT_SETPIX(DPLANE, x, earth[x]);
				
			}
			
		}
		
		
	}
	
}


void CheckLife(BOOL status) {
	
	for (game->pl_check = 0; game->pl_check < game->pl_num && game->status == NORMAL; game->pl_check++) {
		
		if (player[game->pl_check].health <= 0 && player[game->pl_check].life != 0) {
			
			player[game->pl_check].bomb[0] = 0;
			Explosion(player[game->pl_check].x, player[game->pl_check].y - 4, game->pl_check, TRUE);
			
			game->pl_alive--;
			player[game->pl_check].life = 0;
			
			if (player[game->pl_active].life != 0 && status == TRUE) {
				player[game->pl_active].cr_total += 1000;
				
				if(player[game->pl_active].credits <= 59000) {
					player[game->pl_active].credits += 1000;
				}
				
			}
		
		}
		
	}
	
}


void HealthControl(unsigned int bomb, int control_x, int control_y, BOOL mode) {
	
	int control_value, tank_pixel, loop2;
	unsigned int loop1;
	
	for (loop1 = 0; loop1 < game->pl_num; loop1++) {
		
		if (player[loop1].life != 0) {
			
			control_value = 0;
			
			if (bomb == 0) {
				
				control_x = 0;
				control_y = 0;
				
				tank_pixel = tank_pixel_mass[player[loop1].tanknum - 1];
				
				for (control_y = player[loop1].y; control_y >= player[loop1].y - 4; control_y--) {
					for (control_x = player[loop1].x - 4; control_x <= player[loop1].x +3; control_x++) {
						
						if (EXT_GETPIX(DPLANE,control_x,control_y) != FALSE && EXT_GETPIX(LPLANE,control_x,control_y) != FALSE) {
							control_value++;
						}
						
					}
				}
				control_value = tank_pixel - control_value;
				//player[loop1].health = player[loop1].health - control_value;
				
				
				GraySprite16_OR_R(player[loop1].x-11,player[loop1].y -4,5,player[loop1].tank,player[loop1].tank,LPLANE,DPLANE);
				Tube(loop1);
			
			}
			
			else if (bomb == 1) {
				
				for (loop2 = player[loop1].x - 4; loop2 <= player[loop1].x + 4; loop2++) {
					
					if (loop2 >= control_x && loop2 <= control_y) {
						control_value++;
					}
					
				}
				
				control_value *= 2;
				//player[loop1].health -= control_value*2;
					
			}
			
			
			CalcHealth(loop1, control_value, mode);
			
		}
		
	}
	
}

void CalcHealth(unsigned int num, int control_value, BOOL mode) {
	
	if (control_value > 0) {
		if (player[num].type == 2 && player[num].strength >= 5 && mode == TRUE) {
			ForceChooseEnnemi(num);
		}
	}
	
	if (player[num].shield > 0) {
		player[num].shield -= control_value;
		if (player[num].shield < 0) {
			player[num].health += player[num].shield;
			player[num].shield = 0;
		}
	}
	else {
		player[num].health -= control_value;
	}
	
	/*if (player[num].health > 10) {
		player[num].health = 10;
	}*/
	if (player[num].health < 0) {
		player[num].health = 0;
	}
	
}

void TankFall(BOOL mode) {
	
	int yf = 0;
	unsigned int loop1;
	int loop2;
	
	for (loop1 = 0; loop1 < game->pl_num; loop1++) {
	
		if (earth[player[loop1].x] - 1 > player[loop1].y && player[loop1].life != 0) {
			
			if (player[loop1].protect == 0) {
				//MaskTank(loop1);
				
				yf = (int)((earth[player[loop1].x] - 1 - player[loop1].y)/2);
				
				player[loop1].health -= yf;
				
				if (player[loop1].type == 2 && player[loop1].strength >= 5 && mode == TRUE) {
					ForceChooseEnnemi(loop1);
				}
				
			}
				
			MaskTank(loop1);
			
			for (yf = player[loop1].y; yf < earth[player[loop1].x] - 1; yf++) {
				
				player[loop1].y = yf;
				
				if (player[loop1].protect == PARACHUTE) {
					DrawTank(loop1, PARACHUTE);
				}
				else {
					DrawTank(loop1, 1);
				}
				
				for (loop2 = 0; loop2 < 45; loop2++) {
					
					#if defined(VTI)
					VTIPoking();
					#else
					pokeIO(0x600005, 0b10111);
					#endif
					
					if (_keytest(RR_F2)) {
						LeadOut(FASTQUIT);
					}
							
				}
				
				MaskTank(loop1);
				
				/*if (yf == earth[player[loop1].x] - 1) {
					break;
				}
				else */if (player[loop1].protect == 0) {
					yf++;
				}
				
			}
			
			//player[loop1].y = earth[player[loop1].x] - 1;
			
			Tankset(loop1);
			FastFilledRect_Draw_R(DPLANE, player[loop1].x - 4, earth[player[loop1].x] - 1, player[loop1].x + 4, CALC(99,127));
			
			/*#if defined(TESTING)
			for (loop2 = -3; loop2 <= 3; loop2++) {
				
				if (earth[player[loop1].x + loop2] < earth[player[loop1].x]) {
					
					earth[player[loop1].x + loop2] = earth[player[loop1].x];
					
				}
				
			}
			
			FastFilledRect_Draw_R(DPLANE, player[loop1].x - 3, earth[player[loop1].x] - 1, player[loop1].x + 3, CALC(17,21));
			Waitkey();
			FastFilledRect_Erase_R(DPLANE, player[loop1].x - 3, earth[player[loop1].x] - 1, player[loop1].x + 3, CALC(17,21));
			
			Waitkey();
			#endif*/
			
			MaskTank(loop1);
			DrawTank(loop1, 0);
			
			
		}
		
	}
	
}

void Inventory(unsigned int num) {
	
	//Debugging(0);
	
	char string[24];
	int position;
	unsigned int page = 1;
	
	WeaponList(num, 1, 0);
	
	position = 1;
	
	while (position > 0) {
		
		position = WeaponCursor(position, page);
		
		if (position == -10) {
			position = 1;
			if (page != 1) {
				page--;
				WeaponList(num, page, 0);
			}
		}
		else if (position == -20) {
			position = 1;
			if (page != PAGES) {
				page++;
				WeaponList(num, page, 0);
			}
		}
		
		else if (position > 0 && player[num].bomb[MERCHPOS] > 0) {
			if (MERCHPOS < BATTERY) {
				player[num].bomb[0] = MERCHPOS;
			}
			else if (MERCHPOS == BATTERY && player[num].health < 10) {
				--player[num].bomb[BATTERY];
				++player[num].health;
				
			}
			else if (MERCHPOS == PARACHUTE && player[num].protect != PARACHUTE) {
				--player[num].bomb[PARACHUTE];
				player[num].protect = PARACHUTE;
				
			}
			else if ((MERCHPOS == SHIELDLITTLE || MERCHPOS == SHIELDBIG)
							&& player[num].shield < (signed)(bomb_skill[MERCHPOS - 1][2])) {
				--player[num].bomb[MERCHPOS];
				//player[num].protect += SHIELD;
				player[num].shield = bomb_skill[MERCHPOS - 1][2];
			}
			
			sprintf(string,"%d",player[num].bomb[MERCHPOS]);
			GrayDrawStr2B(CALC(80,115),CALC(23,37) + position*8,(char*)"    ",A_SHADED,DPLANE,DPLANE);
			GrayDrawStr2B(CALC(80,115),CALC(23,37) + position*8,string,A_NORMAL,DPLANE,DPLANE);
			#if defined(TI_BIG)
			Dispinf(num);
			#endif
			FontSetSys(F_4x6);
			
		}
		
	}
	
	GrayClearScreen();
	DrawScreen();
	
	DrawClouds();
	
	Wait();
	
}

void MassKill(void) {
	
	unsigned int loop1;
	
	for (loop1 = 0; loop1 < game->pl_num; loop1++) {
		
		if (player[loop1].life > 0) {
			Dispinf(loop1);
			Explosion(player[loop1].x, player[loop1].y - 4, MASSKILL, TRUE);
			player[loop1].health = 0;
			player[loop1].life = 0;
		}
		
	}
	
	Dispinf(game->pl_active);
	game->pl_alive = 0;
	
}


void ChangingWind(void) {
	
	if (game->set[WIND] == 4) {
		game->wind += (5 - random(11));
	}
	else if (game->set[WIND] == 5) {
		game->wind += (10 - random(21));
	}
	else if (game->set[WIND] == 6) {
		game->wind += (25 - random(51));
	}
	
	if (game->wind > 50) {
		game->wind = 50;
	}
	else if (game->wind < -50) {
		game->wind = -50;
	}
	
}


void SetStartValues(void) {
	
	unsigned int loop1, loop2;
	
	for (loop1 = 0; loop1 < game->pl_num; loop1++) {
		
		player[loop1].credits = player[loop1].cr_total = random(6*game->set[START])*500;
		
		for (loop2 = 1; loop2 < MERCH; loop2++) {
			
			if (random(12/game->set[START]) == 0) { //~MERCH
				
				player[loop1].bomb[loop2 + 1] = bomb_skill[loop2][0]*game->set[START];
				
			}
			
		}
		
	}
	
}


void InitClouds(void) {
	
	unsigned int loop1;
	
	if (game->set[WEATHER] == 0) {
		cloud->number = random(9) + 1;
	}
	else if (game->set[WEATHER] == 1) {
		cloud->number = random(CALC(10,15) + 1);
	}
	else if (game->set[WEATHER] == 2) {
		cloud->number = random(CALC(6,11) + 5);
	}
	
	for (loop1 = 0; loop1 < cloud->number; loop1++) {
		
		cloud->pos_set[loop1][0] = random(CALC(160,240));
		cloud->pos_set[loop1][1] = CALC(18,22) + random(6);
		cloud->pos_set[loop1][2] = random(5);
		
	}
	
}


void DrawClouds(void) {
	
	unsigned int loop1;
	
	FastFillRect_R(LPLANE, 0, CALC(17,21), CALC(159,239), CALC(35,39), A_REVERSE);
	
	for (loop1 = 0; loop1 < cloud->number; loop1++) {
		
		cloud->pos_set[loop1][0] += game->wind/10;
		
		if (cloud->pos_set[loop1][0] > CALC(159,239)) {
			cloud->pos_set[loop1][0] = -15;
			cloud->pos_set[loop1][2] = random(5);
		}
		else if (cloud->pos_set[loop1][0] < -15) {
			cloud->pos_set[loop1][0] = CALC(159,239);
			cloud->pos_set[loop1][2] = random(5);
		}
		
		if (random(6 - ABS(game->wind)/10) == 0) {
			
			cloud->pos_set[loop1][1] += 1 - random(3);
			
			if (cloud->pos_set[loop1][1] > CALC(23,27)) {
				cloud->pos_set[loop1][1] -= 2;
			}
			else if (cloud->pos_set[loop1][1] < CALC(18,22)) {
				cloud->pos_set[loop1][1] += 2;
			}
				
		}
		
		ClipSprite16_OR_R(cloud->pos_set[loop1][0], cloud->pos_set[loop1][1], 8, cloud_sprite[cloud->pos_set[loop1][2]], LPLANE);
		
	}
	
}


void SpecialEvent(void) {
	
	unsigned int number, num;
	char string[16];
	
	Rectangle();
	
	num = random(game->pl_num);
	number = random(2);
	
	GrayDrawStrExt(0, CALC(16,30), "EVENT", A_NORMAL | A_CENTERED | A_SHADOWED, F_8x10);
	GrayDrawStrExt(0, CALC(31,45), player[num].name, A_NORMAL | A_CENTERED, F_6x8);
	GrayDrawStrExt(0, CALC(41,55), special_events[random(12)+number*12], A_NORMAL | A_CENTERED, F_4x6);
	
	Sprite16_OR_R(CALC(71,111), CALC(51,65), 16, smiley[number], DPLANE); 
	
	if (number == 0) {
		number = (random(20) + 1)*500;
		sprintf(string, "+ %d cr.", number);
		
		if (player[num].credits < 60000-number) {
			player[num].credits += number;
		} 
		else {
			player[num].credits = 60000;
		}
		
		player[num].cr_total += number;
		
	}
	else {
		number = (random(20) + 1)*500;
		sprintf(string, "- %d cr.", number);
		
		if (player[num].credits > number) {
			player[num].credits -= number;
		}
		else {
			player[num].credits = 0;
		}
		
		
		player[num].cr_total -= number;
		
	}
	
	GrayDrawStrExt(0, CALC(77,91), string, A_NORMAL | A_CENTERED, F_6x8);
	
	Waitkey();
	
	GrayClearScreen();
	DrawScreen();
	DrawClouds();
	
}


void LittleFlash(int x, int y, int direction) {
	
	unsigned int length;
	int y_old;
	int factor;
	
	length = 20 + 10 - random(21);
	
	if (direction == -1 && random(3) != 0) {
		factor = 1;
	}
	else if (direction == 1 && random(3) != 0) {
		factor = -1;
	}
	else {
		if (random(2) == 0) {
			factor = 1;
		}
		else {
			factor = -1;
		}
	}
	
	for (;length > 0; length--, x += factor) {
		
		if (x <= 0 || x >= CALC(159,239)) {
			return;
		}
		else if (y > earth[x]) {
			return;
		}
		
		EXT_SETPIX(DPLANE, x, y);
		
		y_old = y;
		
		y += 2 - random(3);
		
		if (y - y_old == 2) {
			
			EXT_SETPIX(DPLANE, x + factor, y_old + 1);
			
		}
		
	}
	
	
}


void MainFlash(void) {
	
	int x, y = 0, loop1;
	int factor;
	
	do {
		factor = random(cloud->number);
		x = cloud->pos_set[factor][0] + 8;
		y = cloud->pos_set[factor][1] + 4;
	} while (x < 20 || x > CALC(140,220));
	
	
	factor = 0;
	
	for (; y < CALC(100,128) && y <= earth[x]; y++) {
		
		EXT_SETPIX(DPLANE, x - 1, y);
		EXT_SETPIX(LPLANE, x - 1, y);
		EXT_SETPIX(DPLANE, x, y);
		EXT_SETPIX(LPLANE, x, y);
		EXT_SETPIX(DPLANE, x + 1, y);
		EXT_SETPIX(LPLANE, x + 1, y);
		
		x += (factor + 1 - random(3));
		
		if (x < 10) {
			factor = 1;
		}
		else if (x > CALC(149,229)) {
			factor = -1;
		}
		if (x < 2) {
			x = 2;
		}
		else if (x > CALC(157,237)) {
			x = CALC(157,237);
		}
		
		if (random(4) == 0) {
			
			factor += 1 - random(3);
			
			if (factor < -1) {
				factor = -1;
			}
			else if (factor > 1) {
				factor = 1;
			}
			
			if (random(2) == 0) {
				LittleFlash(x, y, factor);
			}
			
		}
		
		
		
	}
	
	
	for (loop1 = 0; loop1 < 200; loop1++) {
		#if defined(VTI)
		VTIPoking();
		#else
		pokeIO(0x600005, 0b10111);
		#endif
		
		if (_keytest(RR_F2)) {
			LeadOut(FASTQUIT);
		}
	}
	
	if (!(x - 2 < 0 || x + 2 > CALC(159,239))) {
		HealthControl(1, x-2, x+2, FALSE);
	}
	
	GrayClearScreen();
	DrawScreen();
	DrawClouds();
	
}

void Earthquake(int x_min, int x_max, unsigned int height, BOOL mode) {
	
	int loop1, y_min, y_max;
	
	if (x_min > x_max) {
		loop1 = x_min;
		x_min = x_max;
		x_max = loop1;
	}
	
	if (x_min < 0) {
		x_min = 0;
	}
	if (x_max > CALC(159,239)) {
		x_max = CALC(159,239);
	}
	
	for (loop1 = x_min; loop1 <= x_max; loop1++) {
		
		/*if ((unsigned int)(CALC(99,127) - earth[loop1] - 1) <= height) { //here could be an error
			y_min = CALC(98,126);
			y_max = earth[loop1];
		}
		else {
			y_min = CALC(98,126) - random((CALC(99,127) - earth[loop1] - 1 - height)/2);
			y_max = x_min - height;
		}*/
		
		y_min = CALC(98,126) - random(6);
		
		if (y_min < earth[loop1]) {
			y_min = CALC(98,126);
		}
		
		y_max = y_min - height;
		
		if (y_max < earth[loop1]) {
			y_max = earth[loop1] - 1;
		}
		
		FastDrawVLine_R(DPLANE, loop1, y_max, y_min, A_REVERSE);
		
	}
	
	for (loop1 = 0; loop1 < 200; loop1++) {
		
		#if defined(VTI)
		VTIPoking();
		#else
		pokeIO(0x600005, 0b10111);
		#endif
		
		if (_keytest(RR_F2)) {
			LeadOut(FASTQUIT);
		}
		
	}
	
	//Waitkey();
	
	EarthControl(x_min, x_max);
	
	TankFall(mode);
	
}

/*void Clouds(void) {
	
	unsigned int loop1;
	
	static unsigned int counter = 0;
	static int coordinates[14];
	
	if (counter == 0) {
		
		for (loop1 = 0; loop1 < game->cloud; loop1++) {
			
			coordinates[loop1] = random(CALC(160,240));
			
		}
		
		counter = 1;
		
	}
	else {
		
		for (loop1 = 0; loop1 < game->cloud; loop1++) {
			
			coordinates[loop1] += game->wind/10;
			
			if (coordinates[loop1] > CALC(159,239)) {
				coordinates[loop1] = 0;
			}
			else if (coordinates[loop1] < -16) {
				coordinates[loop1] = CALC(159,239);
			}
			
		}
		
	}
		
	FastFillRect_R(LPLANE, 0, CALC(17,21), CALC(159,239), CALC(35,39), A_REVERSE);
	
	for (loop1 = 0; loop1 < game->cloud; loop1++) {
		
		ClipSprite16_OR_R(coordinates[loop1], 22 + random(10), 8, clouds[random(5)], LPLANE);
		
	}
	
}*/

//ti89 version: completely done